function testing_noise

close all

num_datasets = 100;

% changing noise (ct)
ct = [0.1 1.0 10.0]; 
all_ct_TPR = [];
all_ct_FPR = [];


for i = 1:size(ct,2) %loop noise
    for j = 1:num_datasets %loop dataset
        formatSpec = '../sim1_data/ct_%.1f/data_%d.mat';
        fname = sprintf(formatSpec,ct(i),j)
        load(fname);

        [~, ~, ~, ~, TPR, FPR] = my_exp(j, ct(i), 100, 40, 0.8, 1, Y, X0, beta_true, pmax);
        all_ct_TPR = [all_ct_TPR, TPR];
        all_ct_FPR = [all_ct_FPR, FPR];
        
        clear Y X0 beta_true pmax
    end %j
    
    mean_TPR = mean(all_ct_TPR,2);
    mean_FPR = mean(all_ct_FPR,2);
    
    formatSpec = 'exp_results/nesi_noise_%.1f/noise_exp/noise_exp_result.mat'; %local  
    fname = sprintf(formatSpec,ct(i))
    save(fname, 'all_ct_TPR', 'all_ct_FPR', 'mean_TPR', 'mean_FPR');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plotting
%     %formatSpec = '/Users/vickydeng/Desktop/Honours Project/simulated_data/noise_%.3f/results/noise_TPR_plot.jpg';
%     formatSpec = '/nesi/project/uoa03491/simulated_data/noise_%.3f/results/noise_TPR_plot.jpg';
%     fname = sprintf(formatSpec,ct(i))
%     boxplot(all_ct_TPR);
%     saveas(gcf,fname)
%     
%     %formatSpec = '/Users/vickydeng/Desktop/Honours Project/simulated_data/noise_%.3f/results/noise_FPR_plot.jpg';
%     formatSpec = '/nesi/project/uoa03491/simulated_data/noise_%.3f/results/noise_FPR_plot.jpg';
%     fname = sprintf(formatSpec,ct(i))
%     boxplot(all_ct_FPR);
%     saveas(gcf,fname)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    all_ct_TPR = [];
    all_ct_FPR = [];

end %i


end %function





