function testing_noise

close all

num_datasets = 100;

% changing noise (ct)
ct = [0.1 1.0 10.0];
all_ct_TPR = [];
all_ct_FPR = [];


for i = 1:size(ct,2) %loop noise
    for j = 1:num_datasets %loop dataset
        formatSpec = '../simulated_data/psi_%.1f/data_%d.mat';
        fname = sprintf(formatSpec,ct(i),j)
        load(fname);

        [~, ~, ~, ~, TPR, FPR] = my_exp(j, ct(i), 100, 40, 0.8, 50, Y, X0, beta_true, pmax);
        all_ct_TPR = [all_ct_TPR, TPR];
        all_ct_FPR = [all_ct_FPR, FPR];
        
        clear Y X0 beta_true pmax
    end %j
    
    mean_TPR = mean(all_ct_TPR,2);
    mean_FPR = mean(all_ct_FPR,2);
    
    formatSpec = 'exp_results/psi_%.1f/noise_exp/noise_exp_result.mat'; %local  
    fname = sprintf(formatSpec,ct(i))
    save(fname, 'all_ct_TPR', 'all_ct_FPR', 'mean_TPR', 'mean_FPR');
    
    all_ct_TPR = [];
    all_ct_FPR = [];

end %i


end %function





