function testing_parameters

close all

num_datasets = 100;  % testing on 100 datasets of 0.05 noise

% changing noise (ct)
ct = [0.1 1.0 10.0];

% changing blocks length (aT: each data set is divided into blocks of length aT) 
% default aT=100
% aT=200 does not work because only works for aT values that 2500/aT is an integer
% possible aT values = 1, 2, 4, 5, 10, 20, 25, 50, 100, 125, 250, 500, 625,
% 1250, 2500
a_T = [5 10 50 100 250 500];
all_aT_TPR = [];
all_aT_FPR = [];
aT_TPR_mat = [];
aT_FPR_mat = [];


% changing active entries of B (q)
% default q=40
q = [20 40 60];
all_q_TPR = [];
all_q_FPR = [];
q_TPR_mat = [];
q_FPR_mat = [];


% changing selection probability (phi)
% default phi=0.8
phi = [0.5 0.6 0.7 0.8 0.9]; 
all_phi_TPR = [];
all_phi_FPR = [];
phi_TPR_mat = [];
phi_FPR_mat = [];

% changing the number of iterations (B)
% default B=50
B = [5 25 50]; %B = [25 50];
all_B_TPR = [];
all_B_FPR = [];
B_TPR_mat = [];
B_FPR_mat = [];

for n = 1:size(ct,2) %loop noise
    for i = 1:num_datasets %loop dataset
        formatSpec = '../simulated_data/psi_%.1f/data_%d.mat';
        fname = sprintf(formatSpec,ct(n),i)
        load(fname);

        fprintf('testing a_T');
        for j = 1:size(a_T,2) %loop different a_T values
            [~, ~, ~, ~, TPR, FPR] = my_exp(i, ct(n), a_T(j), 40, 0.8, 50, Y, X0, beta_true, pmax);
            all_aT_TPR = [all_aT_TPR, TPR];
            all_aT_FPR = [all_aT_FPR, FPR];
        end %a_T

        aT_TPR_mat = [aT_TPR_mat; all_aT_TPR];
        aT_FPR_mat = [aT_FPR_mat; all_aT_FPR];

        all_aT_TPR = [];
        all_aT_FPR = [];


        fprintf('testing q');
        for k = 1:size(q,2) %loop different q values
            [~, ~, ~, ~, TPR, FPR] = my_exp(i, ct(n), 100, q(k), 0.8, 50, Y, X0, beta_true, pmax);
            all_q_TPR = [all_q_TPR, TPR];
            all_q_FPR = [all_q_FPR, FPR];
        end %q

        q_TPR_mat = [q_TPR_mat; all_q_TPR];
        q_FPR_mat = [q_FPR_mat; all_q_FPR];

        all_q_TPR = [];
        all_q_FPR = [];

        
        fprintf('testing phi');
        for m = 1:size(phi,2) %loop different phi values
            [~, ~, ~, ~, TPR, FPR] = my_exp(i, ct(n), 100, 40, phi(m), 50, Y, X0, beta_true, pmax);
            all_phi_TPR = [all_phi_TPR, TPR];
            all_phi_FPR = [all_phi_FPR, FPR];
        end %phi

        phi_TPR_mat = [phi_TPR_mat; all_phi_TPR];
        phi_FPR_mat = [phi_FPR_mat; all_phi_FPR];

        all_phi_TPR = [];
        all_phi_FPR = [];
        
        
        
        fprintf('testing B');
        for l = 1:size(B,2) %loop different B values
            [~, ~, ~, ~, TPR, FPR] = my_exp(i, ct(n), 100, 40, 0.8, B(l), Y, X0, beta_true, pmax);
            all_B_TPR = [all_B_TPR, TPR];
            all_B_FPR = [all_B_FPR, FPR];
        end %phi

        B_TPR_mat = [B_TPR_mat; all_B_TPR];
        B_FPR_mat = [B_FPR_mat; all_B_FPR];

        all_B_TPR = [];
        all_B_FPR = [];

        clear Y X0 beta_true pmax

    end %i

    formatSpec = 'exp_results/psi_%.1f/parameter_exp/aT_exp_result.mat';
    fname = sprintf(formatSpec,ct(n))
    save(fname, 'aT_TPR_mat', 'aT_FPR_mat');

    formatSpec = 'exp_results/psi_%.1f/parameter_exp/q_exp_result.mat';
    fname = sprintf(formatSpec,ct(n))
    save(fname, 'q_TPR_mat', 'q_FPR_mat');
 
    formatSpec = 'exp_results/psi_%.1f/parameter_exp/phi_exp_result.mat';
    fname = sprintf(formatSpec,ct(n))
    save(fname, 'phi_TPR_mat', 'phi_FPR_mat');
    
    formatSpec = 'exp_results/psi_%.1f/parameter_exp/B_exp_result.mat';
    fname = sprintf(formatSpec,ct(n))
    save(fname, 'B_TPR_mat', 'B_FPR_mat');

end %n


end

