function [lambda_min, pre_phi_num_estimator, num_estimator, estimator_idx, beta_prime, beta] = my_exp(a_T, q, phi, B, Y, X0, pmax)
close all

init = 0;

T = size(Y,1)-init;  %T = 365;
K = size(X0,2);  %K = 1464;

mu_T = floor(T/(2*a_T));  % number of odd/even blocks 8
block_seq = 1:mu_T; 
num_blocks = floor(mu_T/2); % number of O1/O2 blocks 4

fprintf('\n');

all_O1_idx = [];
all_O2_idx = [];
all_B1 = [];
all_B2 = [];

[~, ~, lambda_min] = run_lambda_exp(Y, X0, q);

for n = 1:B  
    O1_idx = sort(randperm(mu_T, num_blocks)); %O1 blocks number 8C4=70
    all_O1_idx = [all_O1_idx; O1_idx];
    u = unique(all_O1_idx, 'rows', 'first');
    hasDuplicates = size(u,1) < size(all_O1_idx,1);
    
    %make sure every iteration of B is different
    while hasDuplicates == 1  
        all_O1_idx(end,:) = []; %Delete last row
        O1_idx = sort(randperm(mu_T, num_blocks)); %regenerate random O1 blocks number
        all_O1_idx = [all_O1_idx; O1_idx];
        u = unique(all_O1_idx, 'rows', 'first');
        hasDuplicates = size(u,1) < size(all_O1_idx,1);
    end %while duplicate
    
    O2_idx = block_seq(~ismember(block_seq, O1_idx)); %O2 blocks number
    all_O2_idx = [all_O2_idx; O2_idx];
    
    block_start_1 = init+1+(O1_idx-1)*(2*a_T); %O1 blocks index starts
    block_start_2 = init+1+(O2_idx-1)*(2*a_T); %O2 blocks index starts

    fprintf('.');
    if mod(n,10)==0
        fprintf('\n');
    end

    %big block O'
    X = [];
    y = [];
    for pos1 = block_start_1
        % Construct y and X
        y = [y; Y(pos1:pos1+a_T-1,1)];
%         for ii=1:pmax
%             X = [X Y(pos1-ii:pos1-ii+a_T-1,1:K)];
%         end
        X = [X; X0(pos1:pos1+a_T-1,:)];
    end %pos1
%     size(X)
%     size(y)
    
    [B1, st1] = lasso(X, y, 'Lambda', lambda_min); 
    all_B1 = [all_B1, B1];
          

    %big block O''
    X = [];
    y = [];
    for pos2 = block_start_2
        % Construct y and X
        y = [y; Y(pos2:pos2+a_T-1,1)];
%         for ii=1:pmax
%             X = [X Y(pos2-ii:pos2-ii+a_T-1,1:K)];
%         end
        X = [X; X0(pos2:pos2+a_T-1,:)];
    end %pos2
%     size(X)
%     size(y)
    
    [B2, st2] = lasso(X, y, 'Lambda', lambda_min); 
    all_B2 = [all_B2, B2];

end %n

all_k_prob1 = [];
all_k_prob2 = [];

for p=1:size(B1,1)
    k_prob1 = sum(all_B1(p,:)~=0)/(2*B);
    k_prob2 = sum(all_B2(p,:)~=0)/(2*B);
    all_k_prob1 = [all_k_prob1; k_prob1];
    all_k_prob2 = [all_k_prob2; k_prob2];
end %p

BPA_prob = all_k_prob1+all_k_prob2;
pre_phi_num_estimator = sum(BPA_prob(:,1)>0)

num_estimator = sum(BPA_prob(:,1)>=phi)
estimator_idx = find(BPA_prob(:,1)>=phi)

% if num_estimator>0
%     estimator_idx = find(BPA_prob(:,1)>=phi)
% else
%     [max_estimator,estimator_idx] = max(BPA_prob(:,1))
%     num_estimator = length(estimator_idx)
% end
    
X_prime = X0(:, estimator_idx);
beta_prime = X_prime\Y  %least square
beta = zeros(size(X0, 2),1);
beta(estimator_idx) = beta_prime;

end %function



