function spec_rad = comp_spec_rad(A)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Computes the spectral radius for the given system
%Input:
% A         = A{1}, ..., A{p} are the coeff. of the model
%Output:
% spec_rad  = spectral radius
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[~,p] = size(A);
[~,K] = size(A{1});

Asys = zeros(p*K);
for k = 1 : p
    Asys(1:K, (k-1)*K+1:k*K) = A{k};
    if k < p
      Asys(k*K+1:(k+1)*K, (k-1)*K+1:k*K) = eye(K);
    end
end
spec_rad = max(abs(eig(Asys)));
 
end %function




