function [Atrue, mask, spec_rad] = gen_coeff(K, p, c, z)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Generates the coeff. of the model 
%Input:
% K         = number of variables (number of time series)
% p         = order of the model
% c         = std of matrix coefficients
% z         = max probability of zeros
%Output:
% Atrue     = coeff. of the model
% mask      = pattern of zeros
% spec_rad  = spectral radius
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

spec_rad = -Inf;
while spec_rad<0.999   % maybe cannot stop 0 related to spectral radius
    mask = rand(K) > 1 - z;
    for i=1:K, mask(i,i)=0; end  % diagonal elements are nonzero
    for k = 1:p
        Atrue{k} = c * randn(K) .* (1 - mask);
    end
    spec_rad = comp_spec_rad(Atrue);
    %fprintf('spectral radius = %4g\n', spec_rad);
end


 while spec_rad>0.99999
     for k = 1:p
        Atrue{k} =  Atrue{k}/(spec_rad+0.01);
     end
     spec_rad = comp_spec_rad(Atrue);
     %fprintf('spectral radius = %4g\n', spec_rad);
 end


end %function